## percona-xtradb-cluster-galera-2.x 2.11.2675

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2014 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string

sysname = os.uname()[0].lower()
machine = platform.machine()
print 'Host: ' + sysname + ' ' + machine

#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    static_ssl=[0|1]    Build with static SSL
    with_ssl=path       Prefix for SSL
    debug=n             debug build with optimization level n
    arch=str            target architecture [i686|x86_64]
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

with_ssl     = ''

# Build directory
build_dir    = ''


#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')
with_ssl = ARGUMENTS.get('with_ssl', '/usr/lib64')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)

if int(debug) >= 0 and int(debug) < 3:
    opt_flags = ' -g -O%d -fno-inline' % int(debug)
    dbug = True
elif int(debug) == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'

# Target arch
arch = ARGUMENTS.get('arch', machine)
print 'Target: ' + sysname + ' ' + arch

if arch == 'i386' or arch == 'i686':
    compile_arch = ' -m32 -march=i686'
    link_arth    = compile_arch
    if sysname != 'darwin' and sysname != 'freebsd':
        link_arch    = compile_arch + ' -Wl,-melf_i386'
elif arch == 'x86_64' or arch == 'amd64':
    compile_arch = ' -m64'
    link_arth    = compile_arch
    if sysname != 'darwin' and sysname != 'freebsd':
        link_arch    = compile_arch + ' -Wl,-melf_x86_64'
elif arch == 'ppc64':
    compile_arch = ' -mtune=native'
    link_arch    = ''
elif sysname == 'sunos':
    compile_arch = ''
    link_arch    = ''
else:
    compile_arch = ''
    link_arch    = ''

boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
static_ssl = int(ARGUMENTS.get('static_ssl', 0))
ssl        = int(ARGUMENTS.get('ssl', 1))
tests      = int(ARGUMENTS.get('tests', 1))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))


GALERA_VER = ARGUMENTS.get('version', '2.11')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print 'Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = string.replace(LIBBOOST_PROGRAM_OPTIONS_A, 'boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
# env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS = os.getenv('CPPFLAGS', ''))
env.Replace(LIBPATH = [os.getenv('LIBPATH', '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CPPFLAGS = ' -pthread')

# Freebsd ports are installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH  = ['/usr/local/lib'])
    env.Append(CPPFLAGS = ' -I/usr/local/include ')
if sysname == 'sunos':
   env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()
#
# Set up build and link paths
#

# Include paths
env.Append(CPPPATH = Split('''#/common
                              #/asio
                              #/galerautils/src
                              #/gcomm/src
                              #/gcomm/src/gcomm
                              #/gcache/src
                              #/gcs/src
                              #/wsdb/src
                              #/galera/src
                           '''))

# Library paths
#env.Append(LIBPATH = Split('''#/galerautils/src
#                              #/gcomm/src
#                              #/gcs/src
#                              #/wsdb/src
#                              #/galera/src
#                           '''))

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Replace(CCFLAGS = opt_flags + compile_arch +
                      ' -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Replace(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Replace(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
if sysname != 'sunos':
    env.Append(CXXFLAGS = ' -pipe')


# Linker flags
# TODO: enable '-Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
env.Append(LINKFLAGS = link_arch)

#
# Check required headers and libraries (autoconf functionality)
#

conf = Configure(env)

# System headers and libraries

if not conf.CheckLib('pthread'):
    print 'Error: pthread library not found'
    Exit(1)

if sysname != 'darwin':
    if not conf.CheckLib('rt'):
        print 'Error: rt library not found'
        Exit(1)

if sysname == 'freebsd':
    if not conf.CheckLib('execinfo'):
        print 'Error: execinfo library not found'
        Exit(1)

if sysname == 'sunos':
    if not conf.CheckLib('socket'):
        print 'Error: socket library not found'
        Exit(1)
    if not conf.CheckLib('crypto'):
        print 'Error: crypto library not found'
        Exit(1)
    if not conf.CheckLib('nsl'):
        print 'Error: nsl library not found'
        Exit(1)

if conf.CheckHeader('sys/epoll.h'):
    conf.env.Append(CPPFLAGS = ' -DGALERA_USE_GU_NETWORK')

if conf.CheckHeader('byteswap.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_BYTESWAP_H')

if conf.CheckHeader('endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_ENDIAN_H')
elif conf.CheckHeader('sys/endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_ENDIAN_H')
elif conf.CheckHeader('sys/byteorder.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_BYTEORDER_H')
elif sysname != 'darwin':
    print 'can\'t find byte order information'
    Exit(1)

# Additional C headers and libraries

# boost headers

if not conf.CheckCXXHeader('boost/shared_ptr.hpp'):
    print 'boost/shared_ptr.hpp not found or not usable'
    Exit(1)
conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_SHARED_PTR_HPP')

if conf.CheckCXXHeader('tr1/unordered_map'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_TR1_UNORDERED_MAP')
else:
    if conf.CheckCXXHeader('boost/unordered_map.hpp'):
        conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_UNORDERED_MAP_HPP')
    else:
        print 'no unordered map header available'
        Exit(1)

# pool allocator
if boost == 1:
    # Default suffix for boost multi-threaded libraries
    if sysname == 'darwin':
        boost_library_suffix = '-mt'
    else:
        boost_library_suffix = ''
    if sysname == 'darwin' and extra_sysroot != '':
        boost_library_path = extra_sysroot + '/lib'
    else:
        boost_library_path = ''
    # Use nanosecond time precision
    conf.env.Append(CPPFLAGS = ' -DBOOST_DATE_TIME_POSIX_TIME_STD_CONFIG=1')
    # Common procedure to find boost static library
    boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/local/lib64', '/usr/lib', '/usr/lib64' ]
    def check_boost_library(libBaseName, header, configuredLibPath, autoadd = 1):
        libName = libBaseName + boost_library_suffix
        if configuredLibPath != '' and not os.path.isfile(configuredLibPath):
            print "Error: file '%s' does not exist" % configuredLibPath
            Exit(1)
        if configuredLibPath == '':
           for libpath in boost_libpaths:
               libname = libpath + '/lib%s.a' % libName
               if os.path.isfile(libname):
                   configuredLibPath = libname
                   break
        if configuredLibPath != '':
            if not conf.CheckCXXHeader(header):
                print "Error: header '%s' does not exist" % header
                Exit (1)
            if autoadd:
                conf.env.Append(LIBS=File(configuredLibPath))
            else:
                return File(configuredLibPath)
        else:
            if not conf.CheckLibWithHeader(libs=[libName],
                                           header=header,
                                           language='CXX',
                                           autoadd=autoadd):
                print 'Error: library %s does not exist' % libName
                Exit (1)
            return [libName]
    # Required boost headers/libraries
    #
    if boost_pool == 1:
        if conf.CheckCXXHeader('boost/pool/pool_alloc.hpp'):
            print 'Using boost pool alloc'
            conf.env.Append(CPPFLAGS = ' -DGALERA_USE_BOOST_POOL_ALLOC=1')
            # due to a bug in boost >= 1.50 we need to link with boost_system
            # - should be a noop with no boost_pool.
            if sysname == 'darwin':
                if conf.CheckLib('boost_system' + boost_library_suffix):
                    conf.env.Append(LIBS=['boost_system' + boost_library_suffix])
            check_boost_library('boost_system',
                                'boost/system/error_code.hpp',
                                LIBBOOST_SYSTEM_A)
        else:
            print 'Error: boost/pool/pool_alloc.hpp not found or not usable'
            Exit(1)

    libboost_program_options = check_boost_library('boost_program_options',
                                                   'boost/program_options.hpp',

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (1:2.11.2675-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Generalise fix-mips.patch to resolve same issues on other
    architecutres. Use packed structure, and gcc 64-bit atomic defines
    check.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sun, 30 Aug 2015 22:48:33 +0100

percona-xtradb-cluster-galera-2.x (1:2.11.2675-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  
  [ alexander balderson ]
  * d/p/gcc5.patch: Fixing to build under gcc5 by replacing __PRETTY_FUNCTION__
    with __func__
    (Closes: #778058)

 -- gregor herrmann <gregoa@debian.org>  Tue, 18 Aug 2015 23:13:28 +0200

percona-xtradb-cluster-galera-2.x (1:2.11.2675-1) unstable; urgency=medium

  * New upstream release.
  * Bump epoch to align with actual upstream release versioning.
  * d/control: Bumped Standards-Version to 3.9.6, no changes.

 -- James Page <james.page@ubuntu.com>  Thu, 11 Dec 2014 12:25:51 +0000

percona-xtradb-cluster-galera-2.x (175-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix difference in alignment of long long for MIPS ISA and IA32.
    Use corresponding __atomic_* from libatomic library.
    Add fix-mips.patch.
    Patch by Dejan Latinovic <Dejan.Latinovic@imgtec.com>.
    Closes: #754623.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Fri, 15 Aug 2014 11:18:03 +0100

percona-xtradb-cluster-galera-2.x (175-2) unstable; urgency=medium

  * d/p/detect-atomic.patch: Add check to determine whether -latomic is required
    for GCC atomic built-ins. 
  * d/control: Limit to linux based architectures.

 -- James Page <james.page@ubuntu.com>  Wed, 18 Jun 2014 17:41:14 +0100

percona-xtradb-cluster-galera-2.x (175-1) unstable; urgency=medium

  * New upstream release.
  * d/install,links: Install galera extension to /usr/lib/galera2,
    symlink to /usr/lib.

 -- James Page <jamespage@debian.org>  Mon, 19 May 2014 10:36:11 +0100

percona-xtradb-cluster-galera-2.x (165-1) unstable; urgency=low

  * Initial package (Closes: #734892).

 -- James Page <jamespage@debian.org>  Mon, 10 Feb 2014 13:25:49 +0200

=== debian/control ===
Source: percona-xtradb-cluster-galera-2.x
Section: database
Priority: extra
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: James Page <jamespage@debian.org>
Build-Depends:
 check,
 debhelper (>= 7.0.50~),
 libboost-dev (>= 1.41),
 libboost-program-options-dev (>= 1.41),
 libssl-dev,
 scons
Standards-Version: 3.9.6
Homepage: http://www.percona.com/software/percona-xtradb-cluster/
Vcs-Git: git://git.debian.org/git/pkg-mysql/percona-xtradb-cluster-galera-2.x.git
Vcs-Browser: http://git.debian.org/?p=pkg-mysql/percona-xtradb-cluster-galera-2.x.git

Package: percona-xtradb-cluster-galera-2.x
Architecture: linux-any
Provides: percona-xtradb-cluster-galera-25
Conflicts: galera, percona-xtradb-cluster-galera
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Synchronous multi-master replication plugin for transactional applications
 Galera implements wsrep pluggable interface, as defined in project:
 https://launchpad.net/wsrep and can provide several replication modes
 and topologies, including the ultimate Synchronous Multi-Master replication.
 .
 This package contains the version of galera that will be aligned to
 the Percona XtraDB Cluster 5.5 package.

## percona-xtradb-cluster-galera-2.x 2.11.2675.lucid

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.lucid) lucid; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:06 -0400

percona-xtradb-cluster-galera-2.x (2.11-1) unstable; urgency=low

  * Added GALERA_VERSION variable.

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Mon, 25 Aug 2014 16:12:23 -0500

percona-xtradb-cluster-galera-2.x (0.3-1) unstable; urgency=low

  * Initial release

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Wed,  07 Feb 2014 17:00:00 -0300

percona-xtradb-cluster-galera-2.x (0.2-1) unstable; urgency=low

  * Change package name to include 2.x in its name

 -- Ignacio Nin <ignacio-nin@percona.com>  Tue, 13 Mar 2012 13:14:50 -0300

percona-xtradb-cluster-galera (0.1-1) unstable; urgency=low

  * Initial release

 -- Ignacio Nin <ignacio.nin@percona.com>  Tue, 06 Dec 2011 12:19:07 -0500

=== debian/control ===
Source: percona-xtradb-cluster-galera-2.x
Section: database
Priority: extra
Maintainer: Percona Server Development Team <mysql-dev@percona.com>
Uploaders: Raghavendra Prabhu <raghavendra.prabhu@percona.com>
Build-Depends: debhelper (>= 7.0.50~), scons, libboost-dev (>= 1.41),
    libssl-dev, check, libboost-program-options-dev (>= 1.41)
Standards-Version: 7.0.0

Package: percona-xtradb-cluster-galera-2.x
Architecture: any
Provides: percona-xtradb-cluster-galera-25, galera2
Conflicts: galera, percona-xtradb-cluster-galera
Replaces: galera, percona-xtradb-cluster-galera
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Galera components of Percona XtraDB Cluster
 This package contains the Galera components required by Percona XtraDB Cluster.

Package: percona-xtradb-cluster-garbd-2.x
Architecture: any
Provides: garbd2
Depends: ${shlibs:Depends}, ${misc:Depends}, netcat-openbsd
Description: Garbd components of Percona XtraDB Cluster
 This package contains the garbd of Percona XtraDB Cluster.

Package: percona-xtradb-cluster-galera-2.x-dbg
Architecture: any
Section: debug
Depends: percona-xtradb-cluster-galera-2.x (= ${binary:Version}), ${misc:Depends}
Description: Debugging package for Percona XtraDB Cluster Galera 2.

Package: percona-xtradb-cluster-garbd-2.x-dbg
Architecture: any
Section: debug
Depends: percona-xtradb-cluster-garbd-2.x (= ${binary:Version}), ${misc:Depends}
Description: Debugging package for Percona XtraDB Cluster Garbd 2.

Package: percona-xtradb-cluster-galera-2
Section: database
Architecture: any
Depends: percona-xtradb-cluster-galera-2.x (= ${binary:Version}), ${misc:Depends}
Description: Metapackage for latest version of galera2.

Package: percona-xtradb-cluster-garbd-2
Section: database
Architecture: any
Depends: percona-xtradb-cluster-garbd-2.x (= ${binary:Version}), ${misc:Depends}
Description: Metapackage for latest version of garbd2.

Package: percona-xtradb-cluster-galera2-dbg
Section: database
Architecture: any
Depends: percona-xtradb-cluster-galera-2.x-dbg (= ${binary:Version}), percona-xtradb-cluster-garbd-2.x-dbg (= ${binary:Version}), ${misc:Depends}
Description: Metapackage for latest version of debug packages.

## percona-xtradb-cluster-galera-2.x 2.11.2675.precise

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.precise) precise; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:05 -0400

## percona-xtradb-cluster-galera-2.x 2.11.2675.saucy

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.saucy) saucy; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:06 -0400

## percona-xtradb-cluster-galera-2.x 2.11.2675.squeeze

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.squeeze) squeeze; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:06 -0400

## percona-xtradb-cluster-galera-2.x 2.11.2675.trusty

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.trusty) trusty; urgency=medium

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:10 -0400

## percona-xtradb-cluster-galera-2.x 2.11.2675.wheezy

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.wheezy) wheezy; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:06 -0400

## percona-xtradb-cluster-galera-2.x 112.natty

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform

sysname = os.uname()[0].lower()
machine = platform.machine()
print 'Host: ' + sysname + ' ' + machine

#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    debug=n           debug build with optimization level n
    arch=str          target architecture [i686|x86_64]
    build_dir=dir     build directory, default .
    boost=[0|1]       disable or enable boost libraries
    bpostatic=path    path to libboost_program_options.a
    revno=XXXX        source code revision number
''')


#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

# Build directory
build_dir    = ''


#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)

if int(debug) >= 0 and int(debug) < 3:
    opt_flags = ' -g -O%d -fno-inline' % int(debug)
    dbug = True
elif int(debug) == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'

# Target arch
arch = ARGUMENTS.get('arch', machine)
print 'Target: ' + sysname + ' ' + arch

if arch == 'i386' or arch == 'i686':
    compile_arch = ' -m32 -march=i686'
    link_arch    = compile_arch + ' -Wl,-melf_i386'
elif arch == 'x86_64' or arch == 'amd64':
    compile_arch = ' -m64'
    link_arch    = compile_arch + ' -Wl,-melf_x86_64'
elif sysname == 'sunos':
    compile_arch = ''
    link_arch    = ''
else:
    print 'Unsupported target architecture: ' + arch
    Exit(1)

boost = int(ARGUMENTS.get('boost', 1))
ssl   = int(ARGUMENTS.get('ssl', 1))

GALERA_VER = ARGUMENTS.get('version', '2.1dev')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print 'Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV

BPO_STATIC = ARGUMENTS.get('bpostatic', '')
Export('BPO_STATIC', 'BPO_STATIC')

#
# Set up and export default build environment
#

env = DefaultEnvironment()

# Set up environment for ccache and distcc
env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Freebsd ports are installed under /usr/local 
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH  = ['/usr/local/lib'])
    env.Append(CPPFLAGS = ' -I/usr/local/include')

#
# Set up build and link paths
# 

# Include paths
env.Append(CPPPATH = Split('''#/common
                              #/asio
                              #/galerautils/src
                              #/gcomm/src
                              #/gcomm/src/gcomm
                              #/gcache/src
                              #/gcs/src
                              #/wsdb/src
                              #/galera/src
                           '''))

# Library paths
#env.Append(LIBPATH = Split('''#/galerautils/src
#                              #/gcomm/src
#                              #/gcs/src
#                              #/wsdb/src
#                              #/galera/src
#                           '''))

# Preprocessor flags
if sysname != 'sunos':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
else:
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Replace(CCFLAGS = opt_flags + compile_arch +
                      ' -Wall -Wextra -Werror -Wno-unused-parameter')

# C-specific flags
env.Replace(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Replace(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
if sysname != 'sunos':
    env.Append(CXXFLAGS = ' -pipe')


# Linker flags
# TODO: enable '-Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
env.Append(LINKFLAGS = link_arch)

#
# Check required headers and libraries (autoconf functionality)
#

conf = Configure(env)

# System headers and libraries

if not conf.CheckLib('pthread'):
    print 'Error: pthread library not found'
    Exit(1)

if not conf.CheckLib('rt'):
    print 'Error: rt library not found'
    Exit(1)

if sysname == 'sunos':
    if not conf.CheckLib('socket'):
        print 'Error: socket library not found'
        Exit(1)
    if not conf.CheckLib('crypto'):
        print 'Error: crypto library not found'
        Exit(1)
    if not conf.CheckLib('nsl'):
        print 'Error: nsl library not found'
        Exit(1)

if conf.CheckHeader('sys/epoll.h'):
    conf.env.Append(CPPFLAGS = ' -DGALERA_USE_GU_NETWORK')

if conf.CheckHeader('byteswap.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_BYTESWAP_H')

if conf.CheckHeader('endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_ENDIAN_H')
elif conf.CheckHeader('sys/endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_ENDIAN_H')
elif conf.CheckHeader('sys/byteorder.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_BYTEORDER_H')
else:
    print 'can\'t find byte order information'
    Exit(1)

# Additional C headers and libraries

# boost headers

if not conf.CheckCXXHeader('boost/shared_ptr.hpp'):
    print 'boost/shared_ptr.hpp not found or not usable'
    Exit(1)
conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_SHARED_PTR_HPP')

if conf.CheckCXXHeader('boost/unordered_map.hpp'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_UNORDERED_MAP_HPP')
else:
    if not conf.CheckCXXHeader('tr1/unordered_map'):
        conf.env.Append(CPPFLAGS = ' -DHAVE_TR1_UNORDERED_MAP')
    else:
        print 'no unordered map header available'
        Exit(1)

# pool allocator
if boost == 1:
    # Use nanosecond time precision
    conf.env.Append(CPPFLAGS = ' -DBOOST_DATE_TIME_POSIX_TIME_STD_CONFIG=1')
    # Required boost headers/libraries
    #
    if conf.CheckCXXHeader('boost/pool/pool_alloc.hpp'):
        print 'Using boost pool alloc'
        conf.env.Append(CPPFLAGS = ' -DGALERA_USE_BOOST_POOL_ALLOC=1')
    else:
        print 'Error: boost/pool/pool_alloc.hpp not found or not usable'
else:
    print 'Not using boost'

# asio
if conf.CheckCXXHeader('asio.hpp'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_ASIO_HPP')
else:
    print 'asio headers not found or not usable'
    Exit(1)

# asio/ssl
if ssl == 1:
    if conf.CheckCXXHeader('asio/ssl.hpp'):
        conf.env.Append(CPPFLAGS = ' -DHAVE_ASIO_SSL_HPP')
    else:
        print 'ssl support required but asio/ssl.hpp not found or not usable'
        print 'compile with ssl=0 or check that openssl devel headers are usable'
        Exit(1)
    if conf.CheckLib('ssl'):
        conf.CheckLib('crypto')
    else:
        print 'ssl support required but openssl library not found'
        print 'compile with ssl=0 or check that openssl library is usable'
        Exit(1)

# these will be used only with our softaware
conf.env.Append(CCFLAGS  = ' -pedantic')
conf.env.Append(CXXFLAGS = ' -Weffc++ -Wold-style-cast')

env = conf.Finish()

#
# Set up and export environment for check unit tests
#

# Clone base from default environment
check_env = env.Clone()

conf = Configure(check_env)

# Check header and library

if not conf.CheckHeader('check.h'):
    print 'Error: check header file not found or not usable'
    Exit(1)

if not conf.CheckLib('check'):
    print 'Error: check library not found or not usable'
    Exit(1)

conf.Finish()

# Note: Don't do this, glibc does not like static linking
# Link unit tests statically
# check_env.Append(LINKFLAGS = ' -static')

#
# this follows recipes from http://www.scons.org/wiki/UnitTests
#

def builder_unit_test(target, source, env):
    app = str(source[0].abspath)
    if os.spawnl(os.P_WAIT, app, app)==0:
        open(str(target[0]),'w').write("PASSED\n")
    else:
        return 1
# Create a builder for tests
bld = Builder(action = builder_unit_test)
check_env.Append(BUILDERS = {'Test' :  bld})

Export('check_env')

#
# Run root SConscript with variant_dir
#
SConscript('SConscript', variant_dir=build_dir)

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (112.natty) natty; urgency=low

  * Update distribution

 -- Ignacio Nin <ignacio-nin@percona.com>  Mon, 14 May 2012 16:29:08 +0000

=== debian/control ===
Source: percona-xtradb-cluster-galera-2.x
Section: database
Priority: extra
Maintainer: Ignacio Nin <ignacio.nin@percona.com>
Build-Depends: debhelper (>= 7.0.50~), scons, libboost-dev (>= 1.41),
    libssl-dev, check, libboost-program-options-dev (>= 1.41)
Standards-Version: 3.8.4

Package: percona-xtradb-cluster-galera-2.x
Architecture: any
Provides: percona-xtradb-cluster-galera
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Galera components of Percona XtraDB Cluster
 This package contains the Galera components required by Percona XtraDB Cluster.

## percona-xtradb-cluster-galera-2.x 115.oneiric

=== SConstruct ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ###################################################################
 #
-# Copyright (C) 2010 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2012 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
 #
@@ -30,14 +30,14 @@
 Default target: all
 
 Commandline Options:
-    debug=n           debug build with optimization level n
-    arch=str          target architecture [i686|x86_64]
-    build_dir=dir     build directory, default .
-    boost=[0|1]       disable or enable boost libraries
-    bpostatic=path    path to libboost_program_options.a
-    revno=XXXX        source code revision number
+    debug=n        debug build with optimization level n
+    arch=str       target architecture [i686|x86_64]
+    build_dir=dir  build directory, default: '.'
+    boost=[0|1]    disable or enable boost libraries
+    revno=XXXX     source code revision number
+    bpostatic=path a path to static libboost_program_options.a
 ''')
-
+# bpostatic option added on Percona request
 
 #
 # Default params
@@ -85,6 +85,9 @@
 elif arch == 'x86_64' or arch == 'amd64':
     compile_arch = ' -m64'
     link_arch    = compile_arch + ' -Wl,-melf_x86_64'
+elif arch == 'ppc64':
+    compile_arch = ' -mtune=native'
+    link_arch    = ''
 elif sysname == 'sunos':
     compile_arch = ''
     link_arch    = ''
@@ -95,14 +98,14 @@
 boost = int(ARGUMENTS.get('boost', 1))
 ssl   = int(ARGUMENTS.get('ssl', 1))
 
-GALERA_VER = ARGUMENTS.get('version', '2.1dev')
+GALERA_VER = ARGUMENTS.get('version', '2.2')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 # export to any module that might have use of those
 Export('GALERA_VER', 'GALERA_REV')
 print 'Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV
 
-BPO_STATIC = ARGUMENTS.get('bpostatic', '')
-Export('BPO_STATIC', 'BPO_STATIC')
+LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '');
+Export('LIBBOOST_PROGRAM_OPTIONS_A')
 
 #
 # Set up and export default build environment

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (115.oneiric) oneiric; urgency=low

  * Update distribution

 -- Ignacio Nin <ignacio-nin@percona.com>  Thu, 23 Aug 2012 11:09:52 -0400

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,8 @@
 Package: percona-xtradb-cluster-galera-2.x
 Architecture: any
 Provides: percona-xtradb-cluster-galera
+Conflicts: galera
+Replaces: galera
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Galera components of Percona XtraDB Cluster
  This package contains the Galera components required by Percona XtraDB Cluster.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build:
	scons revno=$(GALERA_REVNO) garb/garbd libgalera_smm.so $(SCONS_ARGS)

%:
	dh $@

## percona-xtradb-cluster-galera-2.x 163.raring

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (163.raring) raring; urgency=low

  * Update distribution

 -- Ignacio Nin <ignacio-nin@percona.com>  Wed, 04 Dec 2013 21:17:06 +0000

## percona-xtradb-cluster-galera-2.x 165

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2012 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string

sysname = os.uname()[0].lower()
machine = platform.machine()
print 'Host: ' + sysname + ' ' + machine

#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    static_ssl=[0|1]    Build with static SSL
    with_ssl=path       Prefix for SSL
    debug=n             debug build with optimization level n
    arch=str            target architecture [i686|x86_64]
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

with_ssl     = ''

# Build directory
build_dir    = ''


#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')
with_ssl = ARGUMENTS.get('with_ssl', '/usr/lib64')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)

if int(debug) >= 0 and int(debug) < 3:
    opt_flags = ' -g -O%d -fno-inline' % int(debug)
    dbug = True
elif int(debug) == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'

# Target arch
arch = ARGUMENTS.get('arch', machine)
print 'Target: ' + sysname + ' ' + arch

if arch == 'i386' or arch == 'i686':
    compile_arch = ' -m32 -march=i686'
    link_arth    = compile_arch
    if sysname != 'darwin' and sysname != 'freebsd':
        link_arch    = compile_arch + ' -Wl,-melf_i386'
elif arch == 'x86_64' or arch == 'amd64':
    compile_arch = ' -m64'
    link_arth    = compile_arch
    if sysname != 'darwin' and sysname != 'freebsd':
        link_arch    = compile_arch + ' -Wl,-melf_x86_64'
elif arch == 'ppc64':
    compile_arch = ' -mtune=native'
    link_arch    = ''
elif sysname == 'sunos':
    compile_arch = ''
    link_arch    = ''
else:
    compile_arch = ''
    link_arch    = ''

boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
static_ssl = int(ARGUMENTS.get('static_ssl', 0))
ssl        = int(ARGUMENTS.get('ssl', 1))
tests      = int(ARGUMENTS.get('tests', 1))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))


GALERA_VER = ARGUMENTS.get('version', '2.8')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print 'Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = string.replace(LIBBOOST_PROGRAM_OPTIONS_A, 'boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
# env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS = os.getenv('CPPFLAGS', ''))
env.Replace(LIBPATH = [os.getenv('LIBPATH', '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CPPFLAGS = ' -pthread')

# Freebsd ports are installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH  = ['/usr/local/lib'])
    env.Append(CPPFLAGS = ' -I/usr/local/include ')
if sysname == 'sunos':
   env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()
#
# Set up build and link paths
#

# Include paths
env.Append(CPPPATH = Split('''#/common
                              #/asio
                              #/galerautils/src
                              #/gcomm/src
                              #/gcomm/src/gcomm
                              #/gcache/src
                              #/gcs/src
                              #/wsdb/src
                              #/galera/src
                           '''))

# Library paths
#env.Append(LIBPATH = Split('''#/galerautils/src
#                              #/gcomm/src
#                              #/gcs/src
#                              #/wsdb/src
#                              #/galera/src
#                           '''))

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Replace(CCFLAGS = opt_flags + compile_arch +
                      ' -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Replace(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Replace(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
if sysname != 'sunos':
    env.Append(CXXFLAGS = ' -pipe')


# Linker flags
# TODO: enable '-Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
env.Append(LINKFLAGS = link_arch)

#
# Check required headers and libraries (autoconf functionality)
#

conf = Configure(env)

# System headers and libraries

if not conf.CheckLib('pthread'):
    print 'Error: pthread library not found'
    Exit(1)

if sysname != 'darwin':
    if not conf.CheckLib('rt'):
        print 'Error: rt library not found'
        Exit(1)

if sysname == 'freebsd':
    if not conf.CheckLib('execinfo'):
        print 'Error: execinfo library not found'
        Exit(1)

if sysname == 'sunos':
    if not conf.CheckLib('socket'):
        print 'Error: socket library not found'
        Exit(1)
    if not conf.CheckLib('crypto'):
        print 'Error: crypto library not found'
        Exit(1)
    if not conf.CheckLib('nsl'):
        print 'Error: nsl library not found'
        Exit(1)

if conf.CheckHeader('sys/epoll.h'):
    conf.env.Append(CPPFLAGS = ' -DGALERA_USE_GU_NETWORK')

if conf.CheckHeader('byteswap.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_BYTESWAP_H')

if conf.CheckHeader('endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_ENDIAN_H')
elif conf.CheckHeader('sys/endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_ENDIAN_H')
elif conf.CheckHeader('sys/byteorder.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_BYTEORDER_H')
elif sysname != 'darwin':
    print 'can\'t find byte order information'
    Exit(1)

# Additional C headers and libraries

# boost headers

if not conf.CheckCXXHeader('boost/shared_ptr.hpp'):
    print 'boost/shared_ptr.hpp not found or not usable'
    Exit(1)
conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_SHARED_PTR_HPP')

if conf.CheckCXXHeader('tr1/unordered_map'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_TR1_UNORDERED_MAP')
else:
    if conf.CheckCXXHeader('boost/unordered_map.hpp'):
        conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_UNORDERED_MAP_HPP')
    else:
        print 'no unordered map header available'
        Exit(1)

# pool allocator
if boost == 1:
    # Default suffix for boost multi-threaded libraries
    if sysname == 'darwin':
        boost_library_suffix = '-mt'
    else:
        boost_library_suffix = ''
    if sysname == 'darwin' and extra_sysroot != '':
        boost_library_path = extra_sysroot + '/lib'
    else:
        boost_library_path = ''
    # Use nanosecond time precision
    conf.env.Append(CPPFLAGS = ' -DBOOST_DATE_TIME_POSIX_TIME_STD_CONFIG=1')
    # Common procedure to find boost static library
    boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/local/lib64', '/usr/lib', '/usr/lib64' ]
    def check_boost_library(libBaseName, header, configuredLibPath, autoadd = 1):
        libName = libBaseName + boost_library_suffix
        if configuredLibPath != '' and not os.path.isfile(configuredLibPath):
            print "Error: file '%s' does not exist" % configuredLibPath
            Exit(1)
        if configuredLibPath == '':
           for libpath in boost_libpaths:
               libname = libpath + '/lib%s.a' % libName
               if os.path.isfile(libname):
                   configuredLibPath = libname
                   break
        if configuredLibPath != '':
            if not conf.CheckCXXHeader(header):
                print "Error: header '%s' does not exist" % header
                Exit (1)
            if autoadd:
                conf.env.Append(LIBS=File(configuredLibPath))
            else:
                return File(configuredLibPath)
        else:
            if not conf.CheckLibWithHeader(libs=[libName],
                                           header=header,
                                           language='CXX',
                                           autoadd=autoadd):
                print 'Error: library %s does not exist' % libName
                Exit (1)
            return [libName]
    # Required boost headers/libraries
    #
    if boost_pool == 1:
        if conf.CheckCXXHeader('boost/pool/pool_alloc.hpp'):
            print 'Using boost pool alloc'
            conf.env.Append(CPPFLAGS = ' -DGALERA_USE_BOOST_POOL_ALLOC=1')
            # due to a bug in boost >= 1.50 we need to link with boost_system
            # - should be a noop with no boost_pool.
            if sysname == 'darwin':
                if conf.CheckLib('boost_system' + boost_library_suffix):
                    conf.env.Append(LIBS=['boost_system' + boost_library_suffix])
            check_boost_library('boost_system',
                                'boost/system/error_code.hpp',
                                LIBBOOST_SYSTEM_A)
        else:
            print 'Error: boost/pool/pool_alloc.hpp not found or not usable'
            Exit(1)
    
    libboost_program_options = check_boost_library('boost_program_options',
                                                   'boost/program_options.hpp',

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (165-0ubuntu1) trusty; urgency=low

  * Initial package.

 -- James Page <james.page@ubuntu.com>  Mon, 10 Feb 2014 13:27:12 +0200

=== debian/control ===
Source: percona-xtradb-cluster-galera-2.x
Section: database
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: James Page <jamespage@debian.org>
Build-Depends:
 check,
 debhelper (>= 7.0.50~),
 libboost-dev (>= 1.41),
 libboost-program-options-dev (>= 1.41),
 libssl-dev,
 scons
Standards-Version: 3.9.5
Homepage: http://www.percona.com/software/percona-xtradb-cluster/
Vcs-Git: git://git.debian.org/git/pkg-mysql/percona-xtradb-cluster-galera-2.x.git
Vcs-Browser: http://git.debian.org/?p=pkg-mysql/percona-xtradb-cluster-galera-2.x.git

Package: percona-xtradb-cluster-galera-2.x
Architecture: any
Provides: percona-xtradb-cluster-galera-25
Conflicts: galera, percona-xtradb-cluster-galera
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Synchronous multi-master replication plugin for transactional applications
 Galera implements wsrep pluggable interface, as defined in project:
 https://launchpad.net/wsrep and can provide several replication modes
 and topologies, including the ultimate Synchronous Multi-Master replication.
 .
 This package contains the version of galera that will be aligned to
 the Percona XtraDB Cluster 5.5 package.

=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-build:
-	scons revno=$(GALERA_REVNO) garb/garbd libgalera_smm.so $(SCONS_ARGS)
+GALERA_REVNO = $(shell cat GALERA-REVISION)
+
+override_dh_auto_build:
+	scons revno=$(GALERA_REVNO) boost_pool=0 garb/garbd libgalera_smm.so $(SCONS_ARGS)
 
 %:
 	dh $@
